/*
 * This is free software
 *
 * quitwm.c - part of xsar program
 * 
 * Author:   Petr Bravenec
 *
 * Version:  0.2 17-Jun-1996
 *
 */

#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>
#include "xsar.h"


/**************************************************************************/
static Atom wm_delete_window;
static void quitwm (Widget, XEvent *, String *, Cardinal *);
static XtActionsRec quitwm_actions[] = {
    {"quit", quitwm}
};


/**************************************************************************/
void AddQuitOptionToWindowManager (Widget widget) {
    XtAppAddActions (
	 XtWidgetToApplicationContext(widget),
	 quitwm_actions,
	 XtNumber(quitwm_actions));
    XtOverrideTranslations (
	 widget,
	 XtParseTranslationTable ( "<Message>WM_PROTOCOLS: quit()"));
    wm_delete_window = XInternAtom (
	 XtDisplay(widget), 
	 "WM_DELETE_WINDOW", 
	 False);
    XSetWMProtocols (
	 XtDisplay(widget), 
	 XtWindow(widget), 
	 &wm_delete_window, 
	 1);
}    

/**************************************************************************/
void quitwm (Widget w, XEvent *event, String *params, Cardinal *nam_params) /* ARGSUSED1 */ {
    if (event->type == ClientMessage &&
	event->xclient.data.l[0] != wm_delete_window) {
	XBell (XtDisplay(w), 0);
	return;
	}
    XtDestroyApplicationContext(XtWidgetToApplicationContext(w));
    exit (0);
}

