/*
 * This is free software
 *
 * showvalues.c - part of xsar program
 * 
 * Author:   Petr Bravenec
 *
 * Version:  0.2 17-Jun-1996
 *
 */

#include <time.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include "xsar.h"

/**************************************************************************/
static void handlerShowValues (Widget w, XtPointer c, XEvent *e, Boolean *cn) /* ARGSUSED0 */ {
    XtRemoveEventHandler (w, ButtonPressMask, FALSE, handlerShowValues, NULL);
    XtDestroyWidget ( *((Widget *)c) );
}

/**************************************************************************/
void ShowValues (Widget parent, int x, int y, Sar *vs) {
    Widget   shell, showv, texts, values;
    Arg      attribs[12];
    char     buf1[32],buf2[32],buf3[32],buf4[32],buf5[32];
    char     buf6[32],buf7[32],buf8[32],buf9[32];
    Position wx, wy;
    int      n;

    XtTranslateCoords (parent, x+3, y+3, &wx, &wy);
    XtSetArg (attribs[0], XtNx, (XtArgVal) wx);
    XtSetArg (attribs[1], XtNy, (XtArgVal) wy);

    shell = XtCreatePopupShell ("ShowValues",transientShellWidgetClass,
              parent, attribs, 2);

    n=0; {
    struct tm *tmx=localtime (&vs->time);
    sprintf (buf1,"%1i:%01i:%01i",tmx->tm_hour,tmx->tm_min,tmx->tm_sec);
    }
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf1); n++;
    sprintf (buf2,"%1.1f",((double)vs->runque)/100.);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf2); n++;
    sprintf (buf3,"%1.1f %%",((double)vs->cpu_idle)/100);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf3); n++;
    sprintf (buf4,"%1.1f %%",((double)vs->cpu_sys)/100);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf4); n++;
    sprintf (buf5,"%1.1f %%",((double)vs->cpu_user)/100);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf5); n++;
    sprintf (buf6,"%1.1f %%",((double)vs->cpu_wait)/100);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf6); n++;
    sprintf (buf7,"%1.1f MB",((double)vs->freemem)/100.);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf7); n++;
    sprintf (buf8,"%1.1f MB",((double)vs->freeswap)/100.);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf8); n++;
    sprintf (buf9,"%1.1f MB",((double)vs->free)/100.);
    XtSetArg (attribs[n], XtNlabel, (XtArgVal) buf9); n++;

#ifdef linux
    /* Cannot get sys_wait from linux kernel */
    sprintf (buf6,"-");
#endif

    showv = XtCreateManagedWidget ("showv",  boxWidgetClass, shell, NULL, 0);
    texts = XtCreateManagedWidget ("texts",  boxWidgetClass, showv, NULL, 0);
    values= XtCreateManagedWidget ("values", boxWidgetClass, showv, NULL, 0);

    XtCreateManagedWidget ("txt1",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt2",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt3",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt4",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt5",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt6",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt7",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt8",labelWidgetClass,texts,NULL,0);
    XtCreateManagedWidget ("txt9",labelWidgetClass,texts,NULL,0);
    
    n=0;
    XtCreateManagedWidget ("val1",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val2",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val3",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val4",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val5",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val6",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val7",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val8",labelWidgetClass,values,&attribs[n++],1);
    XtCreateManagedWidget ("val9",labelWidgetClass,values,&attribs[n++],1);

    XtAddEventHandler (shell,ButtonPressMask, FALSE, handlerShowValues, shell);
    XtPopup (shell, XtGrabExclusive);

    /*
    printf ("%s runque: %1.1f idle: %1.1f Memory: %1.1f RAM + %1.1f SWAP = %1.1f\n",
	    ctime(vs->time),
	    vs->runque,
            vs->cpu_idle,
	    vs->freemem,
	    vs->freeswap,
	    vs->free);
    */
}
