/*
 * This is free software
 *
 * startsadc.c - part of xsar program
 * 
 * Author:   Petr Bravenec
 *
 * Version:  0.2  17-Jul-1996
 *
 */

#include <nlist.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#include "xsar.h"
#include "kmem_seek.h"

#ifdef SVR4 
int           kmem_fd;
unsigned long seek_lbolt;
unsigned long seek_sysinfo;
unsigned long seek_minfo;
unsigned long seek_vminfo;
unsigned long seek_freemem;


void startsadc (void) {
    int i;
    struct nlist nl[] = {
	{"lbolt"},
	{"sysinfo"},
	{"minfo"},
	{"vminfo"},
	{"freemem"},
	{0}
	};
	
    nlist (UNIX_FILE, nl);
    
    i=0;
    if (nl[i].n_type==0 || nl[i].n_value==0) 
	goto CannotGetNameError;
    seek_lbolt = nl[i].n_value;
    
    i=1;
    if (nl[i].n_type==0 || nl[i].n_value==0)
	goto CannotGetNameError;
    seek_sysinfo = nl[i].n_value;
    
    i=2;
    if (nl[i].n_type==0 || nl[i].n_value==0)
	goto CannotGetNameError;
    seek_minfo = nl[i].n_value;

    i=3;
    if (nl[i].n_type==0 || nl[i].n_value==0)
	goto CannotGetNameError;
    seek_vminfo = nl[i].n_value;

    i=4;
    if (nl[i].n_type==0 || nl[i].n_value==0)
	goto CannotGetNameError;
    seek_freemem = nl[i].n_value;
    
    kmem_fd = open(KERNEL_FILE,O_RDONLY);
    if (kmem_fd < 0)
	goto CannotOpenKernelError;

    {
    /* Let we have nodename */
    Arg args[10];
    ReadInfo(args);     
    }
    getsadcvalue();           /* initialize values */
    
    return;
	
CannotGetNameError:
    fprintf (stderr, "Cannot get name %s from %s\n",nl[i].n_name,UNIX_FILE);
    exit(1);
CannotOpenKernelError:
    fprintf (stderr, "Cannot open kernel %s\n",KERNEL_FILE);
    exit(1);
}
#endif
#ifdef linux
void startsadc (void) {
    Arg args[10];
    ReadInfo(args);
    readvalues();
}    
#endif

