/*
 * This is free software
 *
 * xsar.h - part of xsar program
 * 
 * Author:   Petr Bravenec
 *
 * Version:  0.2 17-Jun-1996
 *
 */

#ifndef __XSAR_H_
#define __XSAR_H_

#include <X11/Intrinsic.h>

#ifdef SVR4
#include <time.h>
#include <sys/types.h>
#include <sys/sysinfo.h>
#include <sys/fs/rf_acct.h>


typedef struct {
    unsigned int       lbolt;
    struct sysinfo     si;
    struct minfo       mi;
    struct vminfo      vmi;
    unsigned long      freemem;
    } sa_t;

extern sa_t sa_old;
extern sa_t sa_new;
#endif /* SVR4 */

#define SARNUM 1024

typedef struct {
    time_t time     ;
    int    runque   ;
    int    freemem  ;
    int    freeswap ;
    int    free     ;
    int    cpu_idle ;
    int    cpu_user ;
    int    cpu_sys  ;
    int    cpu_wait ;
    int    pg_in    ;
    int    pg_out   ;
    } Sar;
    
extern Sar  sar[SARNUM];
extern char Node[128];
extern int  sarend;
extern int  sarnum;
extern int  delay;

#ifdef SVR4
void   getsadcvalue  (void);
#endif
void   startsadc     (void);
void   readvalues    (void);
char  *strlrtrim     (char *);
void   ShowInfo      (Widget, XtPointer, XtPointer);
void   ReadInfo      (Arg *);
void   ShowValues    (Widget, int, int, Sar *);
void   AddQuitOptionToWindowManager (Widget);

#endif


